#$ -N matlab_test
#$ -pe mpich 32
#$ -V
#$ -cwd

MATLAB_SCRIPT=calc_mjs.m

MATLAB=/opt/sw/matlab-80/bin/matlab
MDCE=/opt/sw/matlab-dcs_R2012b/toolbox/distcomp/bin/mdce
DIST_DIR=/opt/sw/matlab-80/toolbox/distcomp/bin

NSLOTS_PER_NODE_AVAILABLE=8
NSLOTS_PER_NODE_USED=2
NSLOTS_REDUCED=`echo "$NSLOTS / $NSLOTS_PER_NODE_AVAILABLE * $NSLOTS_PER_NODE_USED" | bc  `
echo "starting run with $NSLOTS_REDUCED processes; $NSLOTS_PER_NODE_USED per node"
uniq $TMPDIR/machines  > $TMPDIR/machines_uniq

JOBMANAGER_HOST=`head -n 1 $TMPDIR/machines_uniq`
JOBMANAGER=matlab_`whoami`

#Kill all old matlab processes
for node in `cat $TMPDIR/machines_uniq`
do
	ssh $node 'for i in `ps axu |grep matlab| tr -s " "|grep -v grep | cut -d " " -f 2`;do echo $i; kill -9 $i; done; rm -rf /tmp/matlab ;'
done

$MDCE start -clean
${DIST_DIR}/startjobmanager -name $JOBMANAGER -remotehost $JOBMANAGER_HOST  -v
${DIST_DIR}/nodestatus -remotehost $JOBMANAGER_HOST
#pdsh is too fast for the license server ...
for worker in `cat $TMPDIR/machines_uniq`
do
	echo starting workers on host $worker
	ssh $worker $MDCE start -clean
	for i in `seq 1 $NSLOTS_PER_NODE_USED`
	do
		${DIST_DIR}/startworker -remotehost $worker -name ${worker}_worker$i -jobmanager $JOBMANAGER -jobmanagerhost $JOBMANAGER_HOST
	done
done

#What we actually want to do:
$MATLAB -nodisplay < $MATLAB_SCRIPT

#Clean up:
${DIST_DIR}/stopjobmanager -name $JOBMANAGER -remotehost $JOBMANAGER_HOST  -v
for worker in `cat $TMPDIR/machines_uniq`
do
	echo stopping worker on $worker
	for i in `seq 1 $NSLOTS_PER_NODE_USED`
	do
		${DIST_DIR}/stopworker -remotehost $worker -name ${worker}_worker$i
	done
	ssh $worker $MDCE stop -clean
done
echo done
